import '../lib/dip_client_sdk.dart';

void main() async {
	var dipClient = new DipClient(DipClient.ENV_INT);
	print("dipClient created");

	var userSeqNum = await dipClient.getSeqNum(seqName: "test-user-seqnum");
	var userSeqNumStr = userSeqNum.toString();
	print("test user seqeuence number = " + userSeqNumStr);

    var userName = "test-user-" + userSeqNumStr + "@dip-test.com";
    var password = "1111";
    var name = "테스트사용자(group)";

    await dipClient.createUser(
        userName: userName,
        password: password,
        name: name
    );
    print("test user created: username = " + userName);

    await dipClient.authenticate(
        userName: userName,
        password: password,
	);

    var identityOwner = userName;
    var identityCategory = '/test-category';
    var identityAttrs = {
        'attr1': 'attr1_value'
    };
    var identityDattrs = {
        'dattr1': 'dattr1_value'
    };

    var identityId = await dipClient.createIdentity(
        identityOwner: identityOwner,
        category: identityCategory,
        attrs: identityAttrs,
        dattrs: identityDattrs,
        //resources: identityResources,
        isTemporary: false,
    );
    print("identity created: identityId = " + identityId);

    var identityId2 = await dipClient.createIdentity(
        identityOwner: identityOwner,
        category: identityCategory,
        attrs: identityAttrs,
        dattrs: identityDattrs,
        //resources: identityResources,
        isTemporary: false,
    );
    print("identity2 created: identityId2 = " + identityId2);

	await dipClient.linkIdentity(
		identityId: identityId,
		targetIdentityId: identityId2,
		linkAttrs: {
			'attr1': 'test attribute'
		},
	);
	print("linkIdentity: " + identityId + " is linked to " + identityId2);

	var redirectInfo = await dipClient.getRedirectInfo(
		identityId: identityId,
	);
	print("getRedirectInfo: redirectInfo = " + redirectInfo.toString());

	var nums = await dipClient.getLinkedIdentityNums(
		targetIdentityIds: [ identityId2 ],
	);
	print("getLinkedIdentityNums: nums = " + nums.toString());

	var getResult = await dipClient.getLinkedIdentities(
		targetIdentityId: identityId2,
	);
	print("getLinkedIdentities: identities = " + getResult['identities'].toString());

/*
	await dipClient.unlinkAll(
		targetIdentityId: identityId2
	);
	print("unlinkAll: all identities unlinked from " + identityId2);

	await dipClient.unlinkIdentity(
		identityId: identityId,
		targetIdentityId: identityId2
	);
	print("unlinkIdentity: " + identityId + " is unlinked from " + identityId2);
*/
}
