import '../lib/dip_client_sdk.dart';

void main() async {
	var dipClient = new DipClient(DipClient.ENV_INT);
	print("dipClient created");

	var userSeqNum = await dipClient.getSeqNum(seqName: "test-user-seqnum");
	var userSeqNumStr = userSeqNum.toString();
	print("test user seqeuence number = " + userSeqNumStr);

	var userName = "test-user-" + userSeqNumStr + "@dip-test.com";
	var password = "1111";
	var name = "테스트사용자(user)";
	var mobile = "01090020552";

	await dipClient.createUser(
		userName: userName,
		password: password,
		name: name
	);
	print("test user created: username = " + userName);

	try {
		var respRequestMobileVerification = await dipClient.requestMobileVerification(
			//userName: userName,
			mobile: mobile
		);
		print("requestMobileVerification succeeded (expected)");
	}
	catch (e) {
		print("requestMobileVerification exception (not supposed to happen): e = " + e.toString());
	}

	try {
		var respSubmitMobileVerification = await dipClient.submitMobileVerification(
			mobile: mobile,
			verificationCode: 'INVALID_VERIFICATION_CODE'
		);
		print("submitMobileVerification succeeded (not supposed to happen)");
	}
	catch (e) {
		print("submitMobileVerification exception (expected): e = " + e.toString());
	}

	await dipClient.authenticate(
		userName: userName,
		password: password
	);
	print("test user authenticated: username = " + userName);

	var respCheckUserName = await dipClient.checkUserName(userName: userName);
	print("checkUserName result = " + respCheckUserName.toString());

	var respCheckUserName2 = await dipClient.checkUserName(userName: userName + ".universe");
	print("checkUserName result2 = " + respCheckUserName2.toString());

	try {
		var respFindUserName = await dipClient.findUserName(
			name: name,
			mobile: mobile,
		);

		print("findUserName succeeded (not supposed to happen)");
	}
	catch (e) {
		print("findUserName exception (expected): e = " + e.toString());
	}

	try {
		var respResetPassword = await dipClient.resetPassword(
			userName: userName,
			mobile: mobile,
			mobileVerification: 'INVALID_VERIFICATION_CODE',
			newPassword: 'NEW_PASSWORD',
		);
		print("resetPassword succeeded (not supposed to happen)");
	}
	catch (e) {
		print("resetPassword exception (expected): e = " + e.toString());
	}

	//var result = await dipClient.deleteUser("madincom@hotmail.com", "1111");
	//print("result = ${result}");

	await dipClient.deleteUser(
		userName: userName,
	);
	print("test user deleted: username = " + userName);
}
